package test.artifact;

import net.openhft.chronicle.ExcerptAppender;
import net.openhft.chronicle.ExcerptTailer;

import org.jetbrains.annotations.NotNull;

public class Msg {

	public long _longField;
	public CharSequence _stringField = new StringBuilder();
	public int _intField;

	public String toString() {
		return
			"{"+
			" long="+_longField+
			" string="+_stringField+
			" int="+_intField+
			" }";
	}

	public Msg() {}
	public Msg(long longField, String stringField, int intField) {
		_longField = longField;
		_stringField = stringField;
		_intField = intField;
	}

	public void write(@NotNull ExcerptAppender out) {
		out.startExcerpt();
		out.writeLong(_longField);
		out.writeUTFΔ((StringBuilder) _stringField);
		out.writeInt(_intField);
		out.finish();
	}

	public void read(@NotNull ExcerptTailer in) {
		_longField = in.readLong();
		in.readUTFΔ((StringBuilder) _stringField);
		_intField = in.readInt();
	}
}
