package test.artifact;

import java.io.IOException;

import net.openhft.chronicle.ExcerptAppender;
import net.openhft.chronicle.ExcerptTailer;
import net.openhft.chronicle.IndexedChronicle;
import net.openhft.chronicle.tcp.ChronicleSink;

public class NonBlockingSink {
	private int _port;
	private ChronicleSink _sink;
    public ExcerptTailer _tailer;
	protected IndexedChronicle _chronicle;
    public ExcerptAppender _appender;

    public NonBlockingSink(IndexedChronicle chronicle, String host, int port) throws IOException {
    	_port = port;
    	_sink = new ChronicleSink(host, port);
    	_tailer = _sink.createTailer();
    	_tailer.toEnd();
    	_chronicle = chronicle;
    	_appender = _chronicle.createAppender();
	}

	public void start() {
    	final Msg header = new Msg();
		new Thread() {
			public void run() {
				while (true) {
					// read from the sink and write to the chronicle
		    		if (_tailer.nextIndex()) {
		            	((StringBuilder)(header._stringField)).delete(0, 1000);
						System.out.println("reading from sink "+_port);
		            	header.read(_tailer);
		            	System.out.println("read from sink "+_port+" "+header);
			        	header.write(_appender);
			        	System.out.println("wrote to local "+header);
		    		} else {
		    			System.out.println("nothing to read from sink "+_port);
		    		}
				}
			}
		}.start();
	}
}
