package test.artifact;

import java.io.IOException;
import java.net.InetAddress;
import java.net.UnknownHostException;

import net.openhft.chronicle.ExcerptAppender;
import net.openhft.chronicle.ExcerptTailer;
import net.openhft.chronicle.IndexedChronicle;
import net.openhft.chronicle.tcp.ChronicleSource;

public class P2 {
	private String _localhost;
	protected IndexedChronicle _chronicle1;
    public ExcerptTailer _tailer1;
	protected IndexedChronicle _chronicle2;
	private int _port2 = 15311;
	private ChronicleSource _source2;
	private ExcerptAppender _appender2;
	private int _port5 = 15322;

	private NonBlockingSink _sink5;

	public P2() throws UnknownHostException {
   		_localhost = InetAddress.getLocalHost().getHostAddress();
	}

	public void start() throws IOException {
    	_chronicle1 = new IndexedChronicle("../chr/h1/chr1");
    	_tailer1 = _chronicle1.createTailer();
    	_tailer1.toEnd();
    	_chronicle2 = new IndexedChronicle("../chr/h1/chr2");
    	_source2 = new ChronicleSource(_chronicle2, _port2);
    	_appender2 = _source2.createAppender();
    	_appender2.toEnd();

    	_sink5 = new NonBlockingSink(new IndexedChronicle("../chr/h1/chr5"), _localhost, _port5);
    	_sink5.start();

    	final Msg header = new Msg();
    	do { // busy loop
			if (_tailer1.nextIndex()) {
				header.read(_tailer1);
				System.out.println(" read "+header);
				header.write(_appender2);
				System.out.println(" wrote "+header);
			}
		} while (true);
	}

	public static void main(String[] args) throws IOException {
		P2 p = new P2();
		p.start();
	}
}
