package test.artifact;

import java.io.IOException;
import java.net.InetAddress;
import java.net.UnknownHostException;

import net.openhft.chronicle.ExcerptAppender;
import net.openhft.chronicle.ExcerptTailer;
import net.openhft.chronicle.IndexedChronicle;
import net.openhft.chronicle.tcp.ChronicleSource;

public class P3 {
	private String _localhost;
	private int _port3 = 15311;
	private NonBlockingSink _sink3;
	protected IndexedChronicle _chronicle3;
    public ExcerptTailer _tailer3;

	protected IndexedChronicle _chronicle4;
	private int _port4 = 15322;
	private ChronicleSource _source4;
	private ExcerptAppender _appender4;

	public P3() throws UnknownHostException {
   		_localhost = InetAddress.getLocalHost().getHostAddress();
	}

	public void start() throws IOException {
    	_chronicle3 = new IndexedChronicle("../chr/h2/chr3");
    	_tailer3 = _chronicle3.createTailer();
    	_tailer3.toEnd();
    	_sink3 = new NonBlockingSink(_chronicle3, _localhost, _port3);

    	_chronicle4 = new IndexedChronicle("../chr/h2/chr4");
    	_source4 = new ChronicleSource(_chronicle4, _port4);
    	_appender4 = _source4.createAppender();
    	_appender4.toEnd();

    	_sink3.start();

    	final Msg header = new Msg();
    	do { // busy loop
			if (_tailer3.nextIndex()) {
				header.read(_tailer3);
				System.out.println(" read "+header);
				header.write(_appender4);
				System.out.println(" wrote "+header);
			}
		} while (true);
	}

	public static void main(String[] args) throws IOException {
		P3 p = new P3();
		p.start();
	}
}
